SystemOrganization addCategory: #'XPF-CodeMarker'!
SystemOrganization addCategory: #'XPF-MonticelloTest'!
SystemOrganization addCategory: #'XPF-OmniBrowserTest'!
SystemOrganization addCategory: #'XPF-Tests-Models'!
SystemOrganization addCategory: #'XPF-Models'!
SystemOrganization addCategory: #'XPF-Seaside-Components'!

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:24' foobar: foobar!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:22' foobar: foobar!
toggleXPF

	self styler: XPFTextStyler new.
	self setTextInDefinitionPanel: target source.! !

OBReadOnlyDefinition subclass: #XPOBRODefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-OmniBrowserTest'!

!XPOBRODefinition methodsFor: 'callbacks' stamp: 'cs 1/15/2009 17:01' foobar: foobar!
processText: aText
	^ 'Begin of meth', String cr, aText, String cr, 'End of Meth'! !

!XPOBRODefinition methodsFor: 'callbacks' stamp: 'topa 1/13/2009 19:29' foobar: foobar!
text
	^ self processText: text! !

!String methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/20/2009 17:17' foobar: foobar!
findAllStrings: aString
	"Returns a collection with all starting indices of the given string in me."
	
	|indices currentStartIndex|
	indices := Bag new.
	currentStartIndex := 1.
	
	[currentStartIndex := (self findString: aString startingAt: currentStartIndex) + 1.
		currentStartIndex > 1 
	] whileTrue: [indices add: currentStartIndex - 1].

	^indices.! !

PluggableTextMorph subclass: #XPFPluggableTextMorph
	instanceVariableNames: 'styler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFPluggableTextMorph class methodsFor: 'instance creation' stamp: 'cs 1/13/2009 18:39' foobar: foobar!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	|styler answer stylerClass |
	answer := self new.
	stylerClass := Smalltalk classNamed: #XPFTextStyler "#SHTextStylerST80".
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 17:11' foobar: foobar!
okToStyle

	^self styler isNil not! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 18:46' foobar: foobar!
setText: aText

	self okToStyle ifFalse: [^super setText: aText].
	super setText: (styler format: aText).
	self styler style: textMorph contents.! !

!XPFPluggableTextMorph methodsFor: 'accessing' stamp: 'cs 1/13/2009 16:58' foobar: foobar!
styler
	^ styler! !

!XPFPluggableTextMorph methodsFor: 'accessing' stamp: 'cs 1/13/2009 16:58' foobar: foobar!
styler: anObject
	styler := anObject! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 17:28' foobar: foobar!
stylerStyled: styledCopyOfText

	textMorph contents runs: styledCopyOfText runs .
	"textMorph paragraph recomposeFrom: 1 to: textMorph contents size delta: 0."  "caused chars to appear in wrong order esp. in demo mode. remove this line when sure it is fixed"
	textMorph updateFromParagraph.
	selectionInterval 
		ifNotNil:[
			textMorph editor
				selectInvisiblyFrom: selectionInterval first to: selectionInterval last;
				storeSelectionInParagraph;
				setEmphasisHere].
	self scrollSelectionIntoView! !

TestCase subclass: #XPFTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFTestCase class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:46' foobar: foobar!
isAbstract
 	^self name = #XPFTestCase! !

!XPFTestCase methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:34' foobar: foobar!
checkAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject"
	
	aTargetObject perform: aSelector asMutator with: anObject.
	self
		assert: (aTargetObject perform: aSelector) == anObject
		! !

XPFTestCase subclass: #XPFUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFUserStoryTest methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:26' foobar: foobar!
setUp! !

!XPFUserStoryTest methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:39' foobar: foobar!
testAttributes
	| us |
	us := XPFUserStory new.
	self
		checkAccessor: #storyName on: us with: 'US + Tasks verwalten';
		checkAccessor: #storyDescription on: us with: 'Dinge tun und Sachen machen';
		checkAccessor: #storyPriority on: us with:'High';
		checkAccessor: #storyEstimate on: us  with: '10';
		checkAccessor: #storyActual on: us  with: '12'.
! !

!Text methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 11:44' foobar: foobar!
backgroundColorAt: characterIndex
    | textBackgroundColor | 
    textBackgroundColor := (self attributesAt: characterIndex) detect: [:att | att isMemberOf: XPFTextBackgroundColor] ifNone: [^Color transparent].
    ^textBackgroundColor color! !

Object subclass: #XPFUserStory
	instanceVariableNames: 'storyName storyDescription storyPriority storyEstimate storyActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Models'!

XPFUserStory class
	instanceVariableNames: 'UserStories'!

XPFUserStory class
	instanceVariableNames: 'UserStories'!

!XPFUserStory class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:02' foobar: foobar!
allUserStories
	(UserStories isNil)
		ifTrue: [UserStories := OrderedCollection new].

	^UserStories! !

!XPFUserStory class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:02' foobar: foobar!
clearUserStories
	UserStories := nil.! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08' foobar: foobar!
descriptionActual
	^MANumberDescription new
		selectorAccessor: #storyActual;
		label: 'Actual';
		priority: 40;
		default: 0;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08' foobar: foobar!
descriptionDescription
	^MAMemoDescription new
		selectorAccessor: #storyDescription;
		label: 'Description';
		priority: 20;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08' foobar: foobar!
descriptionEstimate
	^MANumberDescription new
		selectorAccessor: #storyEstimate;
		label: 'Estimate';
		priority: 40;
		default: 0;
		yourself! !

!XPFUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08' foobar: foobar!
descriptionName
	^MAStringDescription new
		selectorAccessor: #storyName;
		label: 'Name';
		priority: 10;
		default: 'New User Story';
		yourself! !

!XPFUserStory class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:07' foobar: foobar!
descriptionPriority
	^MANumberDescription new
		selectorAccessor: #storyPriority;
		label: 'Priority';
		priority: 30;
		default: 3;
		yourself! !

!XPFUserStory methodsFor: 'description' stamp: 'SR 1/22/2009 15:12' foobar: foobar!
descriptionReport
	^super description 
		select: [:each | #(storyName storyEstimate storyPriority) includes: each accessor selector]! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04' foobar: foobar!
storyActual
	^ storyActual! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04' foobar: foobar!
storyActual: anObject
	storyActual := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyDescription
	^ storyDescription! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyDescription: anObject
	storyDescription := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyEstimate
	^ storyEstimate! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyEstimate: anObject
	storyEstimate := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyName
	^ storyName! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyName: anObject
	storyName := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyPriority
	^ storyPriority! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyPriority: anObject
	storyPriority := anObject! !

!MCStWriter methodsFor: '*XPF' stamp: 'mt 1/13/2009 18:31' foobar: foobar!
writeMethodPreamble: definition
	stream
		cr;
		nextPut: $!!;
		nextPutAll: definition fullClassName;
		nextPutAll: ' methodsFor: ';
		nextPutAll: definition category asString printString;
		nextPutAll: ' stamp: ';
		nextPutAll: definition timeStamp asString printString;
		nextPutAll: ' foobar: ';
		nextPutAll: definition foobar;
		nextPutAll: '!!';
		cr! !

WAComponent subclass: #XPFRootComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFRootComponent class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:26' foobar: foobar!
canBeRoot
	^true! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:44' foobar: foobar!
children
	^Array with: self report.! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:38' foobar: foobar!
createNewUserStory
	| us |
	us := self call: XPFUserStory new asComponent addValidatedForm.
	us ifNotNil: [XPFUserStory allUserStories add: us. self refreshReport].! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:20' foobar: foobar!
deleteUserStory: aUserStory

	(self confirm: 'Do you really want to delele...?') ifTrue: [
		XPFUserStory allUserStories remove: aUserStory.
		self refreshReport.
	].! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:03' foobar: foobar!
editUserStory: aUserStory
| us |

us := self call: (aUserStory description asComponentOn: aUserStory) addValidatedForm.
us ifNotNil: [self refreshReport].! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:33' foobar: foobar!
initialize
	super initialize.
	self initializeReport.! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:13' foobar: foobar!
initializeReport
	self report: (MAReport
 		rows: XPFUserStory allUserStories
 		description: XPFUserStory new descriptionReport).
		
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editUserStory: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteUserStory: text: 'delete';
			yourself).! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 14:39' foobar: foobar!
refreshReport
	self report rows: (XPFUserStory allUserStories).! !

!XPFRootComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 15:06' foobar: foobar!
renderContentOn: html
	html div with: [
		html heading with:'User Stories'.
		
		html anchor callback: [self createNewUserStory]; with: 'Add User Story'.
		
		html div with: self report.
		]! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45' foobar: foobar!
report
	^ report! !

!XPFRootComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45' foobar: foobar!
report: anObject
	report := anObject! !

WAComponent subclass: #XPFUserStoryComponent
	instanceVariableNames: 'userStory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFUserStoryComponent class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:28' foobar: foobar!
canBeRoot
	^true! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:33' foobar: foobar!
initialize
	super initialize.
	userStory := XPFUserStory new.! !

!XPFUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:40' foobar: foobar!
renderContentOn: html
	html heading level:1; with:'User Story'.
	
	html paragraph with:'Name: '.
	html paragraph with:userStory storyName.
	html break.
	
	html paragraph with: 'Description: '.
	html paragraph with: userStory storyDescription.
	html break.

	html paragraph with: 'Proirity: '.
	html paragraph with: userStory storyPriority.
	html break.

	html paragraph with: 'Estimate: '.
	html paragraph with: userStory storyEstimate.
	html break.

	html paragraph with: 'Actual: '.
	html paragraph with: userStory storyActual.
	html break.	
! !

WAComponent subclass: #XPFUserStoryListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Seaside-Components'!

!XPFUserStoryListComponent class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:47' foobar: foobar!
canBeRoot
	^true! !

!XPFUserStoryListComponent methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 13:52' foobar: foobar!
renderContentOn: html
	html heading level1; with: 'All User Stories'.
	
	html unorderedList: [
		XPFUserStory allUserStories do: [ :story | 
			html listItem with: story storyName.
		]
	]! !

!MCMethodDefinition methodsFor: '*XPF' stamp: 'mt 1/13/2009 18:30' foobar: foobar!
foobar
	^'foobar'! !

SHTextStyler subclass: #XPFTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextStyler methodsFor: 'accessing' stamp: 'cs 1/15/2009 17:16' foobar: foobar!
classOrMetaClass: aBehavior! !

!XPFTextStyler methodsFor: 'private' stamp: 'cs 1/13/2009 18:55' foobar: foobar!
privateFormat: aText

	^ aText copyReplaceTokens: 'uuu' with: 'X'! !

!XPFTextStyler methodsFor: 'private' stamp: 'cs 1/15/2009 18:08' foobar: foobar!
privateStyle: aText
	
	aText addAttribute: TextColor green from: 1 to: 3.! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/22/2009 11:39' foobar: foobar!
displayOn: aCanvas using: displayScanner at: somePosition 
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle offset leftInRun line |
	visibleRectangle := aCanvas clipRect.
	offset := somePosition - positionWhenComposed.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft) 
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: 
			[ :i | 
			line := lines at: i.
""			(self text string size > 5) ifTrue: [self haltOnce].""
			self 
				highlightFooOn: aCanvas	at: line;
				displaySelectionInLine: line on: aCanvas.
			line first <= line last ifTrue: 
				[ leftInRun := displayScanner 
					displayLine: line
					offset: offset
					leftInRun: leftInRun ] ]! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/22/2009 15:26' foobar: foobar!
highlightFooOn: aCanvas at: line 
	| cb1 cb2 textLine bgAttr|
	textLine := self text copyFrom: line first to: line last.	
	textLine runs withStartStopAndValueDo: [ :start :stop :attributes |
		bgAttr := attributes detect: [:each | each isMemberOf: XPFTextBackgroundColor] ifNone: [].
		bgAttr ifNotNil: [
			cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1).
			aCanvas 
				fillRectangle: (cb1 left @ line top corner: cb2 right @ line bottom)
				color: bgAttr color]].
! !

TextAttribute subclass: #XPFTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23' foobar: foobar!
= other 
	^ (other class == self class) 
		and: [other color = color]! !

!XPFTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:24' foobar: foobar!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XPFTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 11:22' foobar: foobar!
color
	^ color! !

!XPFTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 11:22' foobar: foobar!
color: anObject
	color := anObject! !

!XPFTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:26' foobar: foobar!
dominates: other
	^ other class == self class! !

!XPFTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23' foobar: foobar!
hash
	^ color hash! !

!XPFTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:25' foobar: foobar!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span style="background-color: #' , color printHtmlString , '">'! !

!XPFTextBackgroundColor methodsFor: 'printing' stamp: 'mt 1/22/2009 11:25' foobar: foobar!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' code: '; print: color! !

!XPFTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:27' foobar: foobar!
writeScanOn: strm
	"Two formats.  c125000255 or cblue;"

	| nn str |
	strm nextPut: $h. "h ... highlight"
	(nn := color name) ifNotNil: [
		(self class respondsTo: nn) ifTrue: [
			^ strm nextPutAll: nn; nextPut: $;]].
	(Array with: color red with: color green with: color blue) do: [:float |
		str := '000', (float * 255) asInteger printString.
		strm nextPutAll: (str copyFrom: str size-2 to: str size)]! !

Morph subclass: #MyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-MonticelloTest'!

!MyClass methodsFor: 'as yet unclassified' stamp: 'mt 1/13/2009 18:30' foobar: foobar!
initialize
	super initialize.
	self color: Color green! !
